import { IEquatableObject, IEquatable } from "../equality";
import { IDecodable, IEncodable } from "../codable";
import { IClonable } from "../clone";
import { Sequence } from "../sequence";
export declare class Set<Element extends IEquatable> implements IEquatableObject<Set<Element>>, IClonable<Set<Element>>, IEncodable, IDecodable<Set<Element>>, IterableIterator<Element> {
    private readonly seq;
    constructor(seq: Sequence<Element>);
    readonly encode: unknown;
    get clone(): Set<Element>;
    [Symbol.iterator](): IterableIterator<Element>;
    next(): IteratorResult<Element>;
    decode(object: unknown): Set<Element>;
    equals(other: Set<Element>): boolean;
}
export declare function set<Element extends IEquatable>(sequence: readonly Element[] | Sequence<Element> | Set<Element>): Set<Element>;
export declare function set<Element extends IEquatable>(...elements: readonly Element[]): Set<Element>;
export declare function set<Element extends IEquatable>(): Set<Element>;
