"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.set = exports.Set = void 0;
const sequence_1 = require("../sequence");
class Set {
    constructor(seq) {
        this.seq = seq.distinct.sorted();
    }
    get clone() {
        return new Set(this.seq.clone);
    }
    [Symbol.iterator]() {
        return this.seq[Symbol.iterator]();
    }
    next() {
        return this.seq[Symbol.iterator]().next();
    }
    decode(object) {
        return set(this.seq.decode(object));
    }
    equals(other) {
        return this.seq.equals(other.seq);
    }
}
exports.Set = Set;
function set(...elements) {
    if (elements.length === 0) {
        return new Set((0, sequence_1.seq)());
    }
    if (elements.length === 1) {
        if (Array.isArray(elements[0])) {
            // array: readonly T[]
            return new Set((0, sequence_1.seq)(elements[0]));
        }
        if (elements[0] instanceof sequence_1.Sequence) {
            // sequence: Sequence<T>
            return new Set(elements[0]);
        }
        if (elements[0] instanceof Set) {
            // set: Set<T>
            return elements[0];
        }
    }
    // elements: readonly T[]
    return new Set((0, sequence_1.seq)(elements));
}
exports.set = set;
//# sourceMappingURL=set.js.map