"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const sequence_1 = require("../sequence");
const set_1 = require("./set");
const assertion_test_1 = require("../equality/assertion.test");
(0, vitest_1.describe)("Set Tests", () => {
    (0, vitest_1.test)("Iterable", () => {
        const s = (0, set_1.set)([4, 1, 3, 2]);
        let actual = (0, sequence_1.seq)();
        for (const element of s) {
            actual = actual.append(element);
        }
        (0, vitest_1.expect)(actual.sorted()).toEqual((0, sequence_1.seq)([1, 2, 3, 4]));
    });
    (0, vitest_1.test)("集合の要素が合致してた場合、equalsがtrueを返す", () => {
        const s1 = (0, set_1.set)([4, 2, 3, 2, 1]);
        const s2 = (0, set_1.set)([3, 3, 1, 2, 4]);
        (0, assertion_test_1.assertEquals)(s1, s2);
    });
});
//# sourceMappingURL=set.test.js.map